/*
    common.h

    Stuff common to singacd and timeacd
*/

#include <windows.h>
#include <commdlg.h>
#include <mmsystem.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>

//
// Special characters in lyric files
//

#define COMMENTCHAR     '['

//
// Timer IDs
//

#define TIMERMASK       0xFF00
#define REPEATMASK      0x00FF
#define UPDATETIMER     0x0100
#define REPEATTIMER     0x0200


//
// data structure for lyric lists
//

typedef struct SONGLINE_ {
    DWORD dwPosition;           // time this line starts
    LPSTR lpText;               // text for this line
} SONGLINE, FAR *LPSONGLINE;

//
// [sing|time]acd.c
//

extern HWND hwndMain;
extern HWND hwndList;

//
// time.c
//

extern int CompareTime(DWORD dwA, DWORD dwB);
extern DWORD TimeDiff(DWORD dwA, DWORD dwB);

//
// mci.c
//

extern MCI_OPEN_PARMS OpenParams;
extern DWORD dwPosition;

extern DWORD GetMode(void);
extern void Play(void);
extern void Stop(void);
extern void Back(void);
extern void Skip(void);
extern void MCIError(DWORD dwErr);
extern void SeekBack(void);
extern void SeekForward(void);

//
// file.c
//

extern LPSONGLINE lpLyrics;
extern char szArtist[256];
extern char szTitle[256];

extern BOOL FAR PASCAL _FileDlg(HWND hWnd, LPSTR szTitle, 
                         LPSTR szFilter, LPSTR szExt,
                         LPSTR szFilePath, WORD nSizePath,
                         LPSTR lpszAppName);
extern DWORD CountLines(int fd);
extern void NukeLyrics(void);
extern BOOL ReadFile(char *szFile);
extern BOOL ReadText(LPSTR lpFile);
extern BOOL ReadLyrics(LPSTR lpFile);
