PAGE 58,132
;******************************************************************************
TITLE doscalls.asm -
;******************************************************************************
;
;   (C) Copyright MICROSOFT Corp., 1990
;
;   Title:	doscalls.asm -
;
;   Version:	1.00a
;
;   Date:	29-Dec-1990
;
;   Author:	RAL
;
;------------------------------------------------------------------------------
;
;   Change log:
;
;      DATE	REV		    DESCRIPTION
;   ----------- --- -----------------------------------------------------------
;   29-Dec-1990 RAL Debug code for DOSMGR device
;   26-Jun-1991 FJ  Adapt for use in TSR and Windows App
;
;==============================================================================

; COPYRIGHT:
;
;   (C) Copyright Microsoft Corp. 1993.  All rights reserved.
;
;   You have a royalty-free right to use, modify, reproduce and
;   distribute the Sample Files (and/or any modified version) in
;   any way you find useful, provided that you agree that
;   Microsoft has no warranty obligations or liability for any
;   Sample Application Files which are modified.
;

Gen_Call_Name MACRO Number, Name
DOS_Call_Name_&Number LABEL BYTE
	db	"&Name", 0
	ENDM

Gen_Call_Name 00, <Terminate process>
Gen_Call_Name 01, <Char input with echo>
Gen_Call_Name 02, <Character output>
Gen_Call_Name 03, <Auxiliary input>
Gen_Call_Name 04, <Auxiliary output>
Gen_Call_Name 05, <Print character>
Gen_Call_Name 06, <Direct console I/O>
Gen_Call_Name 07, <Unfiltered char input>
Gen_Call_Name 08, <Char input w/o echo>
Gen_Call_Name 09, <Display dollar term string>
Gen_Call_Name 0A, <Buffered keyboard input>
Gen_Call_Name 0B, <Check keyboard status>
Gen_Call_Name 0C, <Flush buff, Read kbd>
Gen_Call_Name 0D, <Disk reset>
Gen_Call_Name 0E, <Select disk>
Gen_Call_Name 0F, <Open file with FCB>
Gen_Call_Name 10, <Close file with FCB>
Gen_Call_Name 11, <Find First File>
Gen_Call_Name 12, <Find Next File>
Gen_Call_Name 13, <Delete File>
Gen_Call_Name 14, <Sequential Read>
Gen_Call_Name 15, <Sequential Write
Gen_Call_Name 16, <Create File With FCB>
Gen_Call_Name 17, <Rename File With FCB>
Gen_Call_Name 18, <UNUSED>
Gen_Call_Name 19, <Get Current Disk>
Gen_Call_Name 1A, <Set DTA Address>
Gen_Call_Name 1B, <Get Default Drive Data>
Gen_Call_Name 1C, <Get Drive Data>
Gen_Call_Name 1D, <UNUSED>
Gen_Call_Name 1E, <UNUSED>
Gen_Call_Name 1F, <Get Drive Parameter Blk>
Gen_Call_Name 20, <UNUSED>
Gen_Call_Name 21, <Random Read>
Gen_Call_Name 22, <Random Write>
Gen_Call_Name 23, <Get File Size>
Gen_Call_Name 24, <Set Relative Record>
Gen_Call_Name 25, <Set interrupt vector>
Gen_Call_Name 26, <Create PSP>
Gen_Call_Name 27, <Random block read>
Gen_Call_Name 28, <Random block write>
Gen_Call_Name 29, <Parse filename>
Gen_Call_Name 2A, <Get date>
Gen_Call_Name 2B, <Set date>
Gen_Call_Name 2C, <Get time>
Gen_Call_Name 2D, <Set time>
Gen_Call_Name 2E, <Set/Reset verify flag>
Gen_Call_Name 2F, <Get DTA address>
Gen_Call_Name 30, <Get DOS version>
Gen_Call_Name 31, <Terminate and Stay Res>
Gen_Call_Name 32, <Get device parameter blk>
Gen_Call_Name 33, <Get/Set Control-C Flag>
Gen_Call_Name 34, <Get Address of InDOS>
Gen_Call_Name 35, <Get Interrupt Vector>
Gen_Call_Name 36, <Get Disk Free Space>
Gen_Call_Name 37, <Char Oper>
Gen_Call_Name 38, <Get/Set Current Country>
Gen_Call_Name 39, <Create Directory>
Gen_Call_Name 3A, <Remove Directory>
Gen_Call_Name 3B, <Change Current Directory>
Gen_Call_Name 3C, <Create File with Handle>
Gen_Call_Name 3D, <Open File with Handle>
Gen_Call_Name 3E, <Close File with Handle>
Gen_Call_Name 3F, <Read File or Device>
Gen_Call_Name 40, <Write File or Device>
Gen_Call_Name 41, <Delete File>
Gen_Call_Name 42, <Move file pointer>
Gen_Call_Name 43, <Get/Set File Attributes>
Gen_Call_Name 44, <IOCTL>
Gen_Call_Name 45, <Duplicate File Handle>
Gen_Call_Name 46, <Force Duplicate Handle>
Gen_Call_Name 47, <Get Current Directory>
Gen_Call_Name 48, <Allocate Memory Block>
Gen_Call_Name 49, <Free Memory Block>
Gen_Call_Name 4A, <Resize Memory Block>
Gen_Call_Name 4B, <Load and Exec Program>
Gen_Call_Name 4C, <Terminate with Ret Code>
Gen_Call_Name 4D, <Get Ret Code Child Proc>
Gen_Call_Name 4E, <Find First File>
Gen_Call_Name 4F, <Find Next File>
Gen_Call_Name 50, <Set PSP Segment>
Gen_Call_Name 51, <Get PSP Segment>
Gen_Call_Name 52, <Get List of Lists (invars)>
Gen_Call_Name 53, <Translate BPB>
Gen_Call_Name 54, <Get Verify Flag>
Gen_Call_Name 55, <Create PSP>
Gen_Call_Name 56, <Rename File>
Gen_Call_Name 57, <Get/Set Date/Time File>
Gen_Call_Name 58, <Get/Set Alloc Strategy>
Gen_Call_Name 59, <Get Extended Error Info>
Gen_Call_Name 5A, <Create Temporary File>
Gen_Call_Name 5B, <Create New File>
Gen_Call_Name 5C, <Lock/Unlock File Region>
Gen_Call_Name 5D, <Server DOS call>
Gen_Call_Name 5E, <Net Name/Printer Setup>
Gen_Call_Name 5F, <Network redir stuff>
Gen_Call_Name 60, <NameTrans>
Gen_Call_Name 61, <UNUSED>
Gen_Call_Name 62, <Get PSP Address>
Gen_Call_Name 63, <Hangool call>
Gen_Call_Name 64, <Set Prn Flag>
Gen_Call_Name 65, <Get Extended Country Info>
Gen_Call_Name 66, <Get/Set Global Code Page>
Gen_Call_Name 67, <Set Handle Count>
Gen_Call_Name 68, <Commit File>


;==============================================================================

_DOScall_Name_Off_Table LABEL WORD
DOScall_Name_Off_Table LABEL WORD
	dw	OFFSET DOS_Call_Name_00
	dw	OFFSET DOS_Call_Name_01
	dw	OFFSET DOS_Call_Name_02
	dw	OFFSET DOS_Call_Name_03
	dw	OFFSET DOS_Call_Name_04
	dw	OFFSET DOS_Call_Name_05
	dw	OFFSET DOS_Call_Name_06
	dw	OFFSET DOS_Call_Name_07
	dw	OFFSET DOS_Call_Name_08
	dw	OFFSET DOS_Call_Name_09
	dw	OFFSET DOS_Call_Name_0A
	dw	OFFSET DOS_Call_Name_0B
	dw	OFFSET DOS_Call_Name_0C
	dw	OFFSET DOS_Call_Name_0D
	dw	OFFSET DOS_Call_Name_0E
	dw	OFFSET DOS_Call_Name_0F
	dw	OFFSET DOS_Call_Name_10
	dw	OFFSET DOS_Call_Name_11
	dw	OFFSET DOS_Call_Name_12
	dw	OFFSET DOS_Call_Name_13
	dw	OFFSET DOS_Call_Name_14
	dw	OFFSET DOS_Call_Name_15
	dw	OFFSET DOS_Call_Name_16
	dw	OFFSET DOS_Call_Name_17
	dw	OFFSET DOS_Call_Name_18
	dw	OFFSET DOS_Call_Name_19
	dw	OFFSET DOS_Call_Name_1A
	dw	OFFSET DOS_Call_Name_1B
	dw	OFFSET DOS_Call_Name_1C
	dw	OFFSET DOS_Call_Name_1D
	dw	OFFSET DOS_Call_Name_1E
	dw	OFFSET DOS_Call_Name_1F
	dw	OFFSET DOS_Call_Name_20
	dw	OFFSET DOS_Call_Name_21
	dw	OFFSET DOS_Call_Name_22
	dw	OFFSET DOS_Call_Name_23
	dw	OFFSET DOS_Call_Name_24
	dw	OFFSET DOS_Call_Name_25
	dw	OFFSET DOS_Call_Name_26
	dw	OFFSET DOS_Call_Name_27
	dw	OFFSET DOS_Call_Name_28
	dw	OFFSET DOS_Call_Name_29
	dw	OFFSET DOS_Call_Name_2A
	dw	OFFSET DOS_Call_Name_2B
	dw	OFFSET DOS_Call_Name_2C
	dw	OFFSET DOS_Call_Name_2D
	dw	OFFSET DOS_Call_Name_2E
	dw	OFFSET DOS_Call_Name_2F
	dw	OFFSET DOS_Call_Name_30
	dw	OFFSET DOS_Call_Name_31
	dw	OFFSET DOS_Call_Name_32
	dw	OFFSET DOS_Call_Name_33
	dw	OFFSET DOS_Call_Name_34
	dw	OFFSET DOS_Call_Name_35
	dw	OFFSET DOS_Call_Name_36
	dw	OFFSET DOS_Call_Name_37
	dw	OFFSET DOS_Call_Name_38
	dw	OFFSET DOS_Call_Name_39
	dw	OFFSET DOS_Call_Name_3A
	dw	OFFSET DOS_Call_Name_3B
	dw	OFFSET DOS_Call_Name_3C
	dw	OFFSET DOS_Call_Name_3D
	dw	OFFSET DOS_Call_Name_3E
	dw	OFFSET DOS_Call_Name_3F
	dw	OFFSET DOS_Call_Name_40
	dw	OFFSET DOS_Call_Name_41
	dw	OFFSET DOS_Call_Name_42
	dw	OFFSET DOS_Call_Name_43
	dw	OFFSET DOS_Call_Name_44
	dw	OFFSET DOS_Call_Name_45
	dw	OFFSET DOS_Call_Name_46
	dw	OFFSET DOS_Call_Name_47
	dw	OFFSET DOS_Call_Name_48
	dw	OFFSET DOS_Call_Name_49
	dw	OFFSET DOS_Call_Name_4A
	dw	OFFSET DOS_Call_Name_4B
	dw	OFFSET DOS_Call_Name_4C
	dw	OFFSET DOS_Call_Name_4D
	dw	OFFSET DOS_Call_Name_4E
	dw	OFFSET DOS_Call_Name_4F
	dw	OFFSET DOS_Call_Name_50
	dw	OFFSET DOS_Call_Name_51
	dw	OFFSET DOS_Call_Name_52
	dw	OFFSET DOS_Call_Name_53
	dw	OFFSET DOS_Call_Name_54
	dw	OFFSET DOS_Call_Name_55
	dw	OFFSET DOS_Call_Name_56
	dw	OFFSET DOS_Call_Name_57
	dw	OFFSET DOS_Call_Name_58
	dw	OFFSET DOS_Call_Name_59
	dw	OFFSET DOS_Call_Name_5A
	dw	OFFSET DOS_Call_Name_5B
	dw	OFFSET DOS_Call_Name_5C
	dw	OFFSET DOS_Call_Name_5D
	dw	OFFSET DOS_Call_Name_5E
	dw	OFFSET DOS_Call_Name_5F
	dw	OFFSET DOS_Call_Name_60
	dw	OFFSET DOS_Call_Name_61
	dw	OFFSET DOS_Call_Name_62
	dw	OFFSET DOS_Call_Name_63
	dw	OFFSET DOS_Call_Name_64
	dw	OFFSET DOS_Call_Name_65
	dw	OFFSET DOS_Call_Name_66
	dw	OFFSET DOS_Call_Name_67
	dw	OFFSET DOS_Call_Name_68

LAST_KNOWN_CALL EQU ($-DOScall_Name_Off_Table) / 2
_LastKnownCall	dw  LAST_KNOWN_CALL

Unknown_DOScall db  "Unknown DOS call",0
