// COPYRIGHT:
//
//   (C) Copyright Microsoft Corp. 1993.  All rights reserved.
//
//   You have a royalty-free right to use, modify, reproduce and
//   distribute the Sample Files (and/or any modified version) in
//   any way you find useful, provided that you agree that
//   Microsoft has no warranty obligations or liability for any
//   Sample Application Files which are modified.
//
#include <afxwin.h>
#include <afxcoll.h>
#include "dynamenu.h"
////////////////////////////////////////////////////
//
// Override of CWnd::OnCommand
//
BOOL CDynaMenuWnd::OnCommand(UINT wParam, LONG lParam) 
{
	BOOL bRet = CFrameWnd::OnCommand(wParam, lParam) ;
	if( !bRet && aDynaMenu.Exists() )
	{
		UINT nID = wParam ;

		// Is Command or Menu?
			if( (nID == 0) || ( LOWORD(lParam) != 0 ) )
			{
				// Menu ids can not be 0
				// Also, menus have zero lowords
				return FALSE ;
			}		
			// Is it a dynamic command?
				return aDynaMenu.RunMenu(nID) ;
	}
	return bRet ;	
	
}

CDynaMenuWnd::CDynaMenuWnd()
{
	aDynaMenu.Create(this) ;
}

////////////////////////////////////////////////////////////////////////////
//
//  CDynaMenu
//
CDynaMenu::CDynaMenu()
	: currentID(IDM_FIRST), myMenu(NULL) 
{
} 

BOOL CDynaMenu::Create(CWnd* mywnd)
{
	ptrMenuWnd = mywnd ;
	return TRUE ;
}

BOOL CDynaMenu::RunMenu(UINT nID)
{
	LPFUNC_ONCMD lpfunc ;
	if (menuIDs.Lookup(nID, (void*&)lpfunc) )
	{
		lpfunc(nID,ptrMenuWnd) ;
		return TRUE ;
	}
	else
		return FALSE;
} 

BOOL CDynaMenu::AddMenu(LPFUNC_ONCMD lpfunc, LPCSTR menuString)
{
	if (currentID <= IDM_LAST )
	{
		TRY
		{
			menuIDs.SetAt(currentID, lpfunc) ;
		}
		CATCH( CMemoryException, theException )
		{
			MessageBeep(0) ;
			return FALSE ;
		}
		END_CATCH

		// Has the Dynamic Main Menu Item been Added
		if( myMenu == NULL)
		{
			myMenu = new CMenu ;
			myMenu->CreateMenu() ;
			
			CMenu* pMainMenu = ptrMenuWnd->GetMenu() ;
			
			//Assume last menu is the help menu
			UINT count = pMainMenu->GetMenuItemCount() - 1;
			pMainMenu->InsertMenu(count,
							MF_BYPOSITION | MF_POPUP,
							myMenu->m_hMenu,
							"&DynaMenu");
		}

		// Now add the menu
		if( myMenu->AppendMenu(MF_ENABLED, currentID, menuString) )
		{
			currentID++ ;
			ptrMenuWnd->DrawMenuBar() ;
			return TRUE ;
		}
		else
		{
			menuIDs.RemoveKey(currentID) ;
			currentID-- ;
			return FALSE ;
		}
	}	
	return FALSE ;
} 