' COPYRIGHT:
'
'   (C) Copyright Microsoft Corp. 1993.  All rights reserved.
'
'   You have a royalty-free right to use, modify, reproduce and
'   distribute the Sample Files (and/or any modified version) in
'   any way you find useful, provided that you agree that
'   Microsoft has no warranty obligations or liability for any
'   Sample Application Files which are modified.
'
DefInt A-Z

'***********************************************************
'* Title:
'*      GetFileNameFromDialog$()
'*
'* Parameters:
'*      Caption$    -   Caption of the modal file dialog box
'*      Pattern$    -   Beginning file extension pattern to be
'*                      used in the file dialog box
'*      FileExitsFlag - A flag returned to the calling program
'*                      to indicate whether the file selected by
'*                      the user exists or not.
'*      CancelFlag    - A flag returned to the calling program
'*                      indicating if the user selected cancel
'*                      abort from the file dialog
'* Global variables:
'*      There are five variables which must be declared
'*      in the global module for this function to work
'*      properly.  Include the following declarations in
'*      the global module.
'*
'*          Global gFileDlgCaption$
'*          Global gFileDlgPattern$
'*          Global gFileDlgFileExistFlag As Integer
'*          Global gFileDlgCancelFlag As Integer
'*          Global gFileDlgFileName$
'*
'* Description:
'*      Displays a modal file dialog box and returns the
'*      full path and filename of the file selected from the
'*      dialog box.
'************************************************************
Function GetFileNameFromDialog$ (Caption$, Pattern$, FileExistsFlag, CancelFlag)

    
    gFileDlgCaption$ = Caption$
    gFileDlgPattern$ = Pattern$
    
    FRM_FileDlg.Show 1

    FileExistsFlag = gFileDlgFileExistFlag
    CancelFlag = gFileDlgCancelFlag
    GetFileNameFromDialog$ = gFileDlgFileName$

End Function

Function GetCompanyNameFromFile (FileName$) As String
    
    FileHandle = FreeFile
    Open FileName$ For Input As #FileHandle

    fFound = False
    While Not EOF(FileHandle) And Not fFound
        
        Line Input #FileHandle, l$
        If LTrim$(RTrim$(l$)) <> "" Then
            fFound = True
        End If

    Wend
    
    Close #FileHandle
    
    GetCompanyNameFromFile = l$

End Function

