//*****************************************************************************
//
//	FILE: FILEIO.H
//
//  Comments: This file contains values that are specific to the file
//	      FILEIO.C.
//
//   History: Date	Author		 Reason
//	      --------	---------------  -------
//	      9/30/92	David Flenniken  create/modified
//*****************************************************************************


// Common Dialog section
/****************************************************************************
*                                                                           *
*                          FILE OPEN STRUCTURE                              *
*                                                                           *
****************************************************************************/
#define MAXFILENAMELEN	  256
#define MAXFILETITLELEN   256
typedef struct tagFOCHUNK
   {
      OPENFILENAME of;
      char szFile[MAXFILENAMELEN];
      char szFileTitle[MAXFILETITLELEN];
   }
FOCHUNK;

typedef FOCHUNK FAR *LPFOCHUNK;
typedef FOCHUNK FAR *LPFSCHUNK; 

char gszBuffer[256];
char gszFilter[256];

char gszSaveFile[256];


// StringTable values used when accessing the INI file.
#define IDS_FILTERSTR	      IDS__FILEIO
#define IDS_FILENAME	      IDS__FILEIO+1
#define IDS_SECTION	      IDS__FILEIO+2
#define IDS_TOP 	      IDS__FILEIO+3
#define IDS_LEFT	      IDS__FILEIO+4
#define IDS_BOTTOM	      IDS__FILEIO+5
#define IDS_RIGHT	      IDS__FILEIO+6
#define IDS_GBHOOK	      IDS__FILEIO+8
#define IDS_GBSAVESETTINGS    IDS__FILEIO+9
#define IDS_GBFULLDIS	      IDS__FILEIO+12
#define IDS_ERROPENFILE       IDS__FILEIO+13
#define IDS_ERRFILTER	      IDS__FILEIO+14
#define IDS_ERRCOMPRESS       IDS__FILEIO+15
#define IDS_ERRLOCKING	      IDS__FILEIO+16
#define IDS_ERROOM	      IDS__FILEIO+17
#define IDS_ERRDECOMPRESS     IDS__FILEIO+18
#define IDS_SAVEFILENAME      IDS__FILEIO+19
#define IDS_SETDLG	      IDS__FILEIO+20
#define IDS_VIEWDLG	      IDS__FILEIO+21
#define IDS_TESTDLG	      IDS__FILEIO+22


// Private function prototypes
void  NEAR PASCAL InitOpenStruct(LPFOCHUNK lpFOChunk);
void  NEAR PASCAL InitSaveStruct(LPFSCHUNK lpFSChunk);
