//*************************************************************
//  File name: global.h
//
//  Description: 
//    Global include file for #defines and prototypes
//
//  Functions:
//    none
//
//  Development Team:
//    Sara Williams
//
//Written by Microsoft Product Support Services, Windows Developer Support
//Copyright (c) 1992 Microsoft Corporation. All rights reserved.
//*************************************************************

#include <windows.h>
#include <ddeml.h>

#define IDOK 1          // So the dialog editor won't assign SHAPES as the
                        // value of the okay button. (DlgEditor bug)

#define SYSITEMS 7      // number of system items

#define TOPICS 2        // number of topics the server supports
#define ITEMS 2         // number of items the server supports

#define SAMPLE 0        // indices into topics array
#define SYSTEM 1

#define NUMBER    0     // indices into items array
#define CHANGEBMP 1

#define BITMAPS 3       // number of bitmaps the server stores
#define CIRCLES 0       // indices into bitmap structure array
#define SHAPES  1
#define STRMERS 2

#define STNDWIDTH 1024  // used for sizing and positioning bitmaps and window
#define STNDHEIGHT 768

// used for easy SYSTEM topic support.

typedef struct _ITEMDATA {
   HSZ hszitem;
    HDDEDATA hData;
} ITEMDATA;

// for easy bitmap handle retrieval

typedef struct _HBITMAPDATA {
    HBITMAP hBitmap;
     HDDEDATA hData;
} HBITMAPDATA;

//*** Menu Defines
     #define IDM_ABOUT    100
     #define IDM_SELECTBM 101

//*** Dialog Box Defines
    #define CONTROL_FACTOR 100 // difference between IDC_* value and value we
                               // want to return. 

    #define IDC_ONE        101
    #define IDC_TWO        102
    #define IDC_FOUR       104
    #define IDC_NINE       109
    #define IDC_SIXTEEN    116
    #define IDC_TWENTYFIVE 125

    #define IDC_STREAMERS  102
    #define IDC_CIRCLES    103
    #define IDC_SHAPES     105

//*** String Table Defines
    #define IDS_FORMATS       1
    #define IDS_HELP          2
    #define IDS_ITEMLIST      3
    #define IDS_RTNMSG        4
    #define IDS_STATUS        5
    #define IDS_SYSITEMS      6
    #define IDS_TOPICS        7
    #define IDS_SERVICENAME   8
    #define IDS_SAMPLETOPIC   9
    #define IDS_NWDITEM       10
    #define IDS_CHANGEBMPITEM 11


//*** Function Prototypes
//*** DMLSRV.C
    int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
    long FAR PASCAL MainWndProc(HWND, UINT, WPARAM, LPARAM);
    BOOL FAR PASCAL About(HWND, unsigned, WORD, LONG);
    BOOL FAR PASCAL RequestDialogProc(HWND, unsigned, WORD, LONG);
    BOOL FAR PASCAL SelectDialogProc(HWND, unsigned, WORD, LONG);

//*** Init.c
    BOOL InitApplication(HANDLE);
    BOOL InitInstance(HANDLE, int);
    void InitSystemItems(void);

//*** Callback.c
    HDDEDATA EXPENTRY DdeCallBack(WORD, WORD, HCONV, HSZ, HSZ,    HDDEDATA,
                                  DWORD, DWORD);

//*** EXTERNS for Global Variables
//*** from DMLSRV.c
    extern HANDLE       ghInst;
    extern HWND         ghWndMain;
    extern DWORD        idInst;

    extern char         szMainMenu[];
    extern char         szMainClass[];
    extern HBITMAPDATA  gBitmapHandles[];
    extern int          iSelectedBitmap;
    extern HSZ          ghszDDEMLDemo;
    extern HSZ          ghszTopics[];
    extern HSZ          ghszItems[];
    extern BOOL         bAdviseLoopActive;
    extern FARPROC      lpfnRequestDialogProc;

//*** from init.c
    extern ITEMDATA     gIDSysItems[];

//*** EOF: global.h

