//*************************************************************
//  File name: global.h
//
//  Description: 
//      Global include file for #defines and prototypes
//
//  History:    Date       Author     Comment
//
// Written by Microsoft Product Support Services, Windows Developer Support
// Copyright (c) 1992 Microsoft Corporation. All rights reserved.
//*************************************************************

#include <windows.h>
#include <commdlg.h>

#define _GLOBALINC


/* Menu Defines */
    #define IDM_ABOUT      100
    #define IDM_PRINT      101
    #define IDM_PRINTSETUP 102
    #define IDM_FONTS      103
    #define IDM_EXIT       666

/* Function Prototypes */
/* Main.c */
    int  PASCAL     WinMain (HANDLE, HANDLE, LPSTR, int);
    long FAR PASCAL MainWndProc (HWND, unsigned, WORD, LONG);
    BOOL FAR PASCAL About (HWND, unsigned, WORD, LONG);
    BOOL            ShowPrintSetup (HWND hWnd);
    void            ShowFontBox (HWND hWnd);
    BOOL            ShowPrintBox (HWND hWnd);
    BOOL            PrintIt(HWND hWnd, LPPRINTDLG lpPD);
    HDC             GetPrinterDC (void);
    int  FAR PASCAL PrintAbortDlg (HWND hWnd, unsigned msg, WORD wParam, LONG lParam);
    BOOL FAR PASCAL PrintAbortProc (HDC hDC, short code);


/* Init.c */
    BOOL InitApplication(HANDLE);
    BOOL InitInstance (HANDLE, int);

/* EXTERNS for Global Variables */
    extern HANDLE       ghInst;
    extern HWND         ghWndMain;

    extern char         szMainMenu[];
    extern char         szMainClass[];

// global structure for printing attributes
typedef struct 
{
   HANDLE  hCurrDevMode, hCurrDevNames;
   HFONT   hPrinterFont;
   LOGFONT lfCurrFont;
   char    szPrinter [64] ;
   LPSTR   szDevice, szDriver, szOutput ;
   BOOL    bAbort;
   HWND    hDlgAbort;

} PRINTINFOSTRUCT;

PRINTINFOSTRUCT pis;

// global structure for screen attributes
typedef struct 
{
   HFONT    hScreenFont;
   LOGFONT  lfCurrFont;
   COLORREF crTextColor;

} SCREENINFOSTRUCT;

SCREENINFOSTRUCT sis;

/*** EOF: global.h ***/

