//*************************************************************
// File name: global.h
//
// Description: 
//      Global include file for #defines and prototypes
//
// Development Team:
//      Sara Williams
//
// History:    Date       Author     Comment
//             1/8/92     saraw      Created
//                 
// Written by Microsoft Product Support Services, Windows Developer Support
// Copyright (c) 1992 Microsoft Corporation. All rights reserved.
//**************************************************************


#include <windows.h>
#include <ddeml.h>

#define WM_INITSTUFF (WM_USER+400)  // for initializing data
#define WM_MYCOMMAND (WM_USER+401)  // for status bar updating
#define NUMBITMAPS 5                // number of bitmaps the client stores

#define STNDWIDTH  1024             // Standard size for bitmaps - used to scale
#define STNDHEIGHT 768              // bitmaps and window size for different
                                    // screen resolutions.

#define TOPICS 2                    // number of topics the client uses
#define ITEMS  2                    // number of items the client uses

#define SAMPLE 0                    // indices into topics array
#define SYSTEM 1

#define NUMBER    0                 // indices into items array
#define CHANGEBMP 1

#define CONNECTPOS   0              // Constants for drawing status window
#define CONNECTCHARS 31             // (not used if display is not 8514-size)
#define ADVISEPOS    33
#define ADVISECHARS  17



//*** Menu Defines
    #define IDM_LOWESTMENUID    100
    #define IDM_CONNECTTOSERVER 100
    #define IDM_DOTRANSACTION   101
    #define IDM_STARTHOTADVISE  102
    #define IDM_STOPHOTADVISE   103
    #define IDM_STARTWARMADVISE 104
    #define IDM_STOPWARMADVISE  105
    #define IDM_SYSTOPICS       106
    #define IDM_ITEMLIST        107
    #define IDM_SYSITEMS        108
    #define IDM_FORMATS         109
    #define IDM_STATUS          110
    #define IDM_RTNMSG          111
    #define IDM_SVRHELP         112
    #define IDM_ABOUT           113
    #define IDM_WHATDOIDO       114
    #define IDM_HIGHESTMENUID   114

//*** String table Defines
    #define IDS_SYSTOPICSTITLE  201
    #define IDS_ITEMLISTTITLE   202
    #define IDS_SYSITEMSTITLE   203
    #define IDS_FORMATSTITLE    204                 
    #define IDS_STATUSTITLE     205               
    #define IDS_RTNMSGTITLE     206               
    #define IDS_HELPTITLE       207
    #define IDS_SERVICENAME     208 
    #define IDS_SAMPLETOPIC     209
    #define IDS_NWDITEM         210
    #define IDS_CHANGEBMPITEM   211
//*** Status bar defines

    #define IDD_ADVISESTATUS    1
    #define IDD_CONNECTSTATUS   2

//*** Function Prototypes
//*** DMLCLT.c
    int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
    long FAR PASCAL MainWndProc(HWND, UINT, WPARAM, LPARAM);
    BOOL ShowCoolBitmap(HBITMAP, int, int);
    LPSTR DoSystemTopicRequest(WORD);
 
//*** callback.c
    HDDEDATA EXPENTRY DdeCallBack(WORD, WORD, HCONV, HSZ, HSZ, HDDEDATA, 
                                  DWORD, DWORD);

//*** Init.c
    BOOL InitApplication(HANDLE);
    BOOL InitInstance(HANDLE, int);
    BOOL InitializeCoolBitmaps(void);
    BOOL InitializeStatusBarStuff(BOOL);

//*** status.c
    long FAR PASCAL StatusLineWndProc(HWND, UINT, WPARAM, LPARAM);
    void SetStatusBar(WORD);

//*** dialogs.c
    BOOL FAR PASCAL About(HWND, unsigned, WORD, LONG);
    BOOL FAR PASCAL WhatDoIDo (HWND, unsigned, WORD, LONG);


//*** EXTERNS for Global Variables
//*** from DMLCLT.c
    extern HANDLE       ghInst;
    extern HWND         ghWndMain;
    extern char         szMainMenu[];
    extern char         szMainClass[];
    extern HBITMAP      ghFastBitmapStatus;
    extern HWND         ghWndStatus;
    extern HFONT        ghSmallFont;
    extern BOOL         bHotAdviseLoop;
    extern BOOL         bWarmAdviseLoop;
    extern HCONV        ghConv;
    extern HCONV        ghSysConv;
    extern HSZ          hszServerBase;
    extern HSZ          hszServerInst;
    extern DWORD        dwAsyncXact;
    extern DWORD        idInst;

//*** from init.c
    extern HBITMAP      ghCoolBitmaps[NUMBITMAPS];
    extern WORD         gwOrigBitmapWidth;
    extern WORD         gwOrigBitmapHeight;
    extern WORD         gwConnectPos;
    extern WORD         gwAdvisePos;
    extern WORD         gwBarHeight;
    extern BOOL         bMonochrome;
    extern BOOL         bEGAMode;
    extern char         szNullString[];
    extern char         szStatusLine[];

//*** from status.c
    extern HDC          ghFastStatusDC;
    extern char         szBuffer[256];

//*** EOF: global.h

