//*****************************************************************************
//
//	FILE: GLOBALS.H
//
//  Comments: This file contains global variables.
//
//   History: Date	Author		 Reason
//	      --------	---------------  -------
//	      9/30/92	David Flenniken  create/modified
//*****************************************************************************
//StringTable for each file...	 Fill in here

// In order to keep the string table defines unique each header file
// will start at the following values.
#define IDS__ALL	       1440
#define IDS__INIT	       1600
#define IDS__FILEIO	       1760
#define IDS__MAIN	       1920
#define IDS__VIEW	       2240
#define IDS__TLHLP	       2560

#define IDS_TITLE	       IDS__ALL

//Defines for string lengths...
#define MSG_SHORT	  48
#define MSG_NORMAL	 128
#define MSG_LONG	 256


// External messages communication notification messages <- these should
// be public!
#define IDX_REGISTERAPP      1000
#define IDX_INITIALRC	     1001
#define IDX_CUSTOMRCCHANGED  1002
#define IDX_UPDATERC	     1003

// Internal messages
#define INT_DISPLAY	  1002

// global menu identifiers
#define IDM_VIEWDLG	  201
#define IDM_SETDLG	  202
#define IDM_TESTDLG	  203

// Icon
#define ID_Icon    5000
#define ID_RcWait  5001


// general globals
HWND	    ghwnd;  // main window handle
HANDLE	    ghInst; // Windows instance
HWND	    ghLB;   // Main Listbox handle

// When displaying the controls in the Set dialog each control needs to
// have a string "title" associated with it.  This is where they are
// defined.  They are actually set up in TABLES.INC.
typedef struct taplabel_str
{
   LPSTR lpStr;
} LABEL_STR, * NPLABEL_STR;

#define NULL_STRMAX  1
#define DWORDHEX_STRMAX 1+1
#define INT_STRMAX  1+1
#define WORD_STRMAX 1+1
#define RECT_STRMAX 4+1
#define GUIDE_STRMAX 9+1
#define BYTE_STRMAX  1+1
#define RGLPDF_STRMAX 16+1
#define RESERVED_STRMAX 8+1
#define RGBFALC_STRMAX 32+1


extern LABEL_STR gdw_str[DWORDHEX_STRMAX];
extern LABEL_STR gNull_str[NULL_STRMAX];
extern LABEL_STR gint_str[INT_STRMAX];
extern LABEL_STR gword_str[WORD_STRMAX];
extern LABEL_STR grect_str[RECT_STRMAX];
extern LABEL_STR gguide_str[GUIDE_STRMAX];
extern LABEL_STR gbyte_str[BYTE_STRMAX];
extern LABEL_STR grglpdf_str[RGLPDF_STRMAX];
extern LABEL_STR greserved_str[RESERVED_STRMAX];
extern LABEL_STR grgbfalc_str[RGBFALC_STRMAX];

// This structure type is used when the RC structure option contains flags.
// this structure holds the flag and the coorisponding value.  See TABLES.INC
// to see what they are...
typedef struct tagOPTION_STR
{
   DWORD  wValue;
   NPSTR  npStr;
} OPTION_STR, * NPOPTION_STR;

#define NULLMAX  1
#define RCPMAX	 2+1
#define RCIPMAX   2+1
#define ALCMAX	 23+1
#define GUIDEMAX 9+1
#define LPCMMAX  7+1
#define RCOMAX	 13+1
#define RRMMAX	 5+1
#define RCORMAX  4+1
#define RCDMAX	 5+1
#define RCRTMAX  8+1

extern OPTION_STR gNull[NULLMAX];
extern OPTION_STR grcp[RCPMAX];
extern OPTION_STR grcip[RCIPMAX];
extern OPTION_STR galc[ALCMAX];
extern OPTION_STR glpcm[LPCMMAX];
extern OPTION_STR grco[RCOMAX];
extern OPTION_STR grrm[RRMMAX];
extern OPTION_STR grcor[RCORMAX];
extern OPTION_STR grcd[RCDMAX];
extern OPTION_STR gguide[GUIDEMAX];
extern OPTION_STR grcrt[RCRTMAX];


// The following defines are used to define what type of information is held
// in a particular RC field.  They are broken up into Major and minor types.
// These are used throught the program to help stire execution.

#define TYPE_BASIC	 0x0800
#define TYPE_FLAGS	 0x1000
#define TYPE_HEX	 0x2000
#define TYPE_POINTER	 0x4000
#define TYPE_OTHER	 0x8000
#define TYPE_MAJOR	 0xF800

#define TYPE_INT	 0x0001
#define TYPE_WORD	 0x0002
#define TYPE_DWORD	 0x0004
#define TYPE_POINT	 0x0008
#define TYPE_RECT	 0x0010
#define TYPE_GUIDE	 0x0020

#define TYPE_ALC	 0x0001
#define TYPE_DF 	 0x0002
#define TYPE_RES	 0x0004
#define TYPE_HOT	 0x0008

#define TYPE_SYC	 0x0001
#define TYPE_SYE	 0x0002
#define TYPE_SYV	 0x0004
#define TYPE_LANGUAGE	 0x0008
#define TYPE_USER	 0x0010

// A couple places in this program these values are used to control loops.
// For instance, the display loop.
#define NUMOF_RC_OPTIONS   30+1  // for the Null termainator
#define NUMOF_RCR_OPTIONS  17+1  // for the Null termainator

// This structure defines how data is stored in this application.  This is
// the most important data structure.  Basically, for every data field in
// both the RC and RCRESULT sturctures there is a coorisponding OPTIONS
// structure.  See TABLES.INC for more information about how they are set!
// Understanding how this structure is set up is key to understanding this
// application.
typedef struct tagOptions
{
   BYTE  bSelect;    // An array of booleans that  determine if the option
		     //  was selected or not.  (TRUE or FALSE)
   NPSTR npStr;      // A near pointer to the character string
   NPSTR npFrmtStr;  // A near pointer to the format string for displaying
		     //  the information.
   void  *lplabels;  // pointer to label structures
   WORD  wType;      // This field is set depending on the type of information
		     //  that will be displayed.  See the TYPE_ flags above.
   void far *lpData; // Offset into structure where data is located
   void far *lpDataTmp; // Offset into structure where Temparay data is located
   void *npAlphaStr; // A near pointer to all the options that are available
		     //  for the set dlg.

} OPTIONS, FAR * LPOPTIONS;

// arrays that contain the application's information.  Is TABLES.INC
extern OPTIONS gRc_Opt[NUMOF_RC_OPTIONS];
extern OPTIONS gRcR_Opt[NUMOF_RCR_OPTIONS];

// pointers to the above arrays.
extern LPOPTIONS glpRc_Tmp;
extern LPOPTIONS glpRcr_Tmp;

// temparary memory used when copying the RCRESULT structure.
HANDLE ghsyeMem;
HANDLE ghsycMem;
HANDLE ghsyvMem;
HANDLE ghpendata;

// These three globals contain the state of the checkable menu items.  They
// are also INI options.
BOOL   gbHook;
BOOL   gbSaveSettings;
BOOL   gbFullDis;

// This one holds the position of the mainwind.
RECT   grect;

// The upper left hand location of each one of the modeless dialogs is saved
// and used each time the dialogs are displayed.
int giSetx;
int giSety;
int giTestx;
int giTesty;
int giViewx;
int giViewy;

// Custom wait cursor, This one is obvious.
HCURSOR ghRcWaitCursor;

// You find, you see...
extern BOOL gbFirstTime;

// Handles and addresses for the modeless dialogs
HWND	ghDlgCurrent;
FARPROC glpSetDlg;
FARPROC glpViewDlg;
FARPROC glpTestDlg;
HWND	ghwndSet;
HWND	ghwndView;
HWND	ghwndTest;


// This global will contain the RC structure that will be used to control
// all the recognition sessions.  This is also an element of the OPTIONS
// array.  See TABLES.INC for more information.
RC grc;


// This RC structure will be used by the set dialog box each time the user
// makes any changes in the RC structure.  When they choose "done" or the
// dialog loses focus, these values will be copied on top of the values in
// grc.  This global is also part of the OPTIONS array.  See TABLES.INC
// for more information.
RC grcTmp;

// This global will contain the results of a recognition session.  When the
// WM_HOOKRCRESULT message is prcessed this variable gets filled.
RCRESULT gresult;


// If another appilication wants to communicate with RCDump these variables
// are used.
extern WORD gwAppComMessage;
extern HANDLE ghAppComWin;
