/*
 * DLLASSIST.H
 *
 * Definitions, classes, and prototypes for a DLL that provides
 * CLSID_LinksAssistant objects to a linking container applications.
 *
 * Copyright (c)1993 Microsoft Corporation, All Rights Reserved
 *
 * Kraig Brockschmidt, Software Design Engineer
 * Microsoft Systems Developer Relations
 *
 * Internet  :  kraigb@microsoft.com
 * Compuserve:  >INTERNET:kraigb@microsoft.com
 */


#ifndef _DLLASSIS_H_
#define _DLLASSIS_H_


#include "lnkassis.h"

void FAR PASCAL ObjectDestroyed(void);


//DLLASSIS.CPP
//This class factory object creates Koala objects.

class __far CLinksClassFactory : public IClassFactory
    {
    protected:
        ULONG           m_cRef;         //Reference count on class object

    public:
        CLinksClassFactory(void);
        ~CLinksClassFactory(void);

        //IUnknown members
        STDMETHODIMP         QueryInterface(REFIID, LPVOID FAR *);
        STDMETHODIMP_(ULONG) AddRef(void);
        STDMETHODIMP_(ULONG) Release(void);

        //IClassFactory members
        STDMETHODIMP         CreateInstance(LPUNKNOWN, REFIID, LPVOID FAR *);
        STDMETHODIMP         LockServer(BOOL);
    };

typedef CLinksClassFactory FAR * LPCLinksClassFactory;


#endif //_DLLASSIS_H_
