// mapmode.h

// struct to store the mapping mode attributes that
// we are concerned with

typedef struct
   {
   int   mapMode;
   DWORD windOrg;
   DWORD viewOrg;
   DWORD windExt;
   DWORD viewExt;
   }
   MMDATA;

typedef MMDATA NEAR * NPMMDATA;
typedef MMDATA FAR  * LPMMDATA;



// row and col constants for DisplayValues routine (formatting)

#define ROWHEADER    1 
#define ROWMOUSELOC  3
#define ROWRECTCOORD 4
#define ROWCLIENTDIM 5
#define ROWMAPMODE   7
#define ROWWINDORG   8
#define ROWWINDEXT   9
#define ROWVIEWORG   10
#define ROWVIEWEXT   11

#define COLDEVICE     25
#define COLLOGICAL    40
#define COLMAPMODE    20
#define COLLABEL       1


// menu items

#define IDM_ABOUT          100
#define IDM_TESTMM         101
#define IDM_TESTRECT       102
#define IDM_DISPLAYDOG     103
#define IDM_DISPLAYVALUES  104
#define IDM_DISPLAYBOTH    105
#define IDM_HELP           106


// prototypes

int PASCAL       WinMain        (HANDLE, HANDLE, LPSTR, int);
BOOL             InitApplication(HANDLE);
BOOL             InitInstance   (HANDLE, int);
long FAR PASCAL  MainWndProc    (HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL  About          (HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL  MMDlgProc      (HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL  RectDlgProc    (HWND, unsigned, WORD, LONG);

void NEAR PASCAL DrawMyBitmap( HDC, HBITMAP, LPRECT );
void NEAR PASCAL InitRectBM  ( void );
void NEAR PASCAL InitDisplayCoordinates( int, int );
void NEAR PASCAL DisplayValues  ( HWND, HDC );
void NEAR PASCAL GetMMData      ( HDC , NPMMDATA );
void NEAR PASCAL ApplyMMData    ( HDC, NPMMDATA );

BOOL NEAR PASCAL GetDlgControlValues( HWND , NPMMDATA  );
BOOL NEAR PASCAL SetDlgControlValues( HWND , NPMMDATA  );
void NEAR PASCAL SetEditValues( HWND, LPRECT );
BOOL NEAR PASCAL GetEditValues( HWND, LPRECT ); 

