#include <afxwin.h>
#include <afxcoll.h>
#include "numedit.h"

////////////////////////////////////////////////////////////
//
// Implement CNumEdit Class
//

BEGIN_MESSAGE_MAP(CNumEdit, CEdit)
	ON_WM_CHAR()
END_MESSAGE_MAP()

//
// Define statics
//
WNDPROC CNumEdit::pfnSuperWndProc = NULL ;

//
//
//
LONG CALLBACK __export
CNumEdit::FirstMsgOnlyWndProc(HWND hWnd, UINT msg, UINT wParam, LONG lParam)
{
	//
	// Construct the object and then attach the hWnd to it.
	//
	CNumEdit* pNumEdit = new CNumEdit ;
	pNumEdit->Attach(hWnd) ;
	
	pNumEdit->bCreatedByClassName = TRUE ;
	
	//
	// Subclass the window by changing the window procedure to AfxWndProc
	// and pass the current message to it.
	//
	::SetWindowLong(hWnd, GWL_WNDPROC, (DWORD)AfxWndProc);

#ifdef STRICT
	return ::CallWindowProc((WNDPROC)AfxWndProc, hWnd, msg, wParam, lParam);
#else
	return ::CallWindowProc((FARPROC)AfxWndProc, hWnd, msg, wParam, lParam);
#endif
	//DER
}

//
// BOOL RegisterMyClass() ;
//
BOOL CNumEdit::RegisterMyClass()
{
	WNDCLASS wcls ;
	
	if(!::GetClassInfo(NULL, "edit", &wcls) )
	{
		return FALSE ;
	}

	if (pfnSuperWndProc == NULL) 
		pfnSuperWndProc = wcls.lpfnWndProc ;
	
	ASSERT( pfnSuperWndProc == wcls.lpfnWndProc) ;

	static const char szClassName[] = "numedit" ;
	if(::GetClassInfo(AfxGetInstanceHandle(), szClassName, &wcls))
	{
		return (wcls.lpfnWndProc == CNumEdit::FirstMsgOnlyWndProc) ;
	}
	
	wcls.lpfnWndProc = CNumEdit::FirstMsgOnlyWndProc ;
	wcls.hInstance = AfxGetInstanceHandle() ;
	wcls.lpszClassName = szClassName ;
	
	return (RegisterClass(&wcls) !=0) ;
}

//
// PostNcDestroy - delete the object we created on the heap. 
//
void CNumEdit::PostNcDestroy()
{
	if( bCreatedByClassName )
		delete this;
}

//
// OnChar member function
//
void CNumEdit::OnChar(UINT nChar, UINT nRep, UINT nFlags)
{
	if ((nChar >= '0' && nChar <= '9') || nChar == VK_BACK )
		CEdit::OnChar(nChar, nRep, nFlags) ;
	else
		MessageBeep(0) ;
}


