////////////////////////////////////////////////////////////////
//
//
//
#ifndef __OWIN_I_H__
#define __OWIN_I_H__

#include <afxcoll.h>

#include <afxdlgs.h>


// Constants
//

const int TABNUM = 8 ;

const int DefaultMaxColumns = 80 ;
const int DefaultMaxLines = 2048 ;

// Class definitions
//
class COutputWindow : public CFrameWnd {
	public:
		// Constructor 
			COutputWindow() ;
		
		// Destructor
			~COutputWindow() ;
		
		// Create
			BOOL Create(const char FAR* lpWindowName = "Output Window") ;
		
		// Use
			void Display(const char *someChars, int count) ;
			int GetInput(char *someChars, int count ) ;
			BOOL ReturnInput(char *someChars, int count) ;
			BOOL FlushInput() ;
					
		// Window Messages 
			afx_msg void OnPaint() ;
			afx_msg int OnCreate( LPCREATESTRUCT cs ) ;
			afx_msg void OnSize( UINT type, int x, int y) ;
			afx_msg void OnHScroll( UINT how, UINT pos, CScrollBar* control ) ;
			afx_msg void OnVScroll( UINT how, UINT pos, CScrollBar* control ) ;
			
		// Menu Messages
			afx_msg void OnFont() ;
			afx_msg void OnClearBuffer() ;
			
			DECLARE_MESSAGE_MAP();

	private:
		// Internal Functions 
			void scrollOffTop() ;
			void lineFeed() ;
			void calcTextMetrics() ;			
			
		// member variables
			LOGFONT lf ;
			COLORREF rgbTextColor ;
		
			CStringList lineList ;
			CString inputBuffer ;

			int cxChar ;
			int cyChar ;
			int nHscrollPos ;
			int nVscrollPos ;
			int cxCaps ;
			int nMaxWidth ;
			int cxClient ;
			int cyClient ;
			int nVscrollMax ;
			int nHscrollMax ;
			int maxLines ;
			int maxColumns ;

};

#endif //__OWIN_I_H__

