// COPYRIGHT:
//
//   (C) Copyright Microsoft Corp. 1993.  All rights reserved.
//
//   You have a royalty-free right to use, modify, reproduce and
//   distribute the Sample Files (and/or any modified version) in
//   any way you find useful, provided that you agree that
//   Microsoft has no warranty obligations or liability for any
//   Sample Application Files which are modified.
//
#include <afxwin.h>
#include "wio.h"
#include "owin.h"
////////////////////////////////////////////
// C Wrapper Code
//

////////////////////////////////////////////
// Globals
//
CObList aList ;

///////////////////////////////////////////
// Code
//
extern "C" 
{

//
// create
//
DWORD EXPORTED 
wioCreate(LPCSTR lpWindowName)
{ 
	BOOL ret ;
	COutputWindow *pOut = new COutputWindow ;
	
	if (lpWindowName)
		ret = pOut->Create(lpWindowName) ;
	else
		ret = pOut->Create() ;
	
	ASSERT(ret == TRUE) ;
	
	aList.AddTail(pOut) ;
	return (DWORD)pOut ;
}

//
// display
//
void EXPORTED  
wioDisplay(DWORD wioHandle, LPCSTR someChars, int count)
{
	COutputWindow *pOutWnd = (COutputWindow *)wioHandle ;
	
	if( aList.Find(pOutWnd) != NULL )
	{
		pOutWnd->Display(someChars, count) ;
	}
}

//
// getInput
// 
int EXPORTED  
wioGetInput(DWORD wioHandle, LPSTR someChars, int count)
{
	COutputWindow *pOutWnd = (COutputWindow *)wioHandle ;
	
	if( aList.Find(pOutWnd) != NULL )
	{
		return pOutWnd->GetInput(someChars, count) ;
	}
	
	return 0 ;
}

//
// flushInput -- returns true if successful
//

BOOL EXPORTED
wioFlushInput(DWORD wioHandle)
{
	COutputWindow *pOutWnd = (COutputWindow *)wioHandle ;
	
	if( aList.Find(pOutWnd) != NULL )
	{
		return pOutWnd->FlushInput() ;
	}
	
	return FALSE ;
}

//
// wioReturnInput - returns number of character added
//

BOOL EXPORTED
wioReturnInput(DWORD wioHandle, LPSTR someChars, int count)
{
	COutputWindow *pOutWnd = (COutputWindow *)wioHandle ;
	
	if( aList.Find(pOutWnd) != NULL )
	{
		return pOutWnd->ReturnInput(someChars, count) ;
	}
	
	return FALSE ;
}


//
// destroy
//
BOOL EXPORTED 
wioDestroy(DWORD wioHandle)
{
	COutputWindow *pOutWnd = (COutputWindow *)wioHandle ;
	
	POSITION thePosition = aList.Find(pOutWnd) ;
	if(thePosition != NULL )
	{
		// Delete the output window object
			delete pOutWnd ;
		
		// Remove the pointer from the list
			aList.RemoveAt(thePosition) ;
		
		return TRUE ;
	}
	
	return FALSE ;
}

} // extern "C"

