/* resource.h : Defines the resource constants for the Hello application.
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and Microsoft
// QuickHelp documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.
//
// Note that this window only contains #define directives.  This makes it
// suitable for including in the generic.rc resource file.
*/

#define IDM_ABOUT   113


#define WM_INITSTUFF (WM_USER+400)  // for initializing data
#define WM_MYCOMMAND (WM_USER+401)  // for status bar updating
#define NUMBITMAPS 5                // number of bitmaps the client stores

#define STNDWIDTH  1024             // Standard size for bitmaps - used to scale
#define STNDHEIGHT 768              // bitmaps and window size for different
                                    // screen resolutions.

#define TOPICS 2                    // number of topics the client uses
#define ITEMS  2                    // number of items the client uses

#define SAMPLE 0                    // indices into topics array
#define SYSTEM 1

#define NUMBER    0                 // indices into items array
#define CHANGEBMP 1

#define CONNECTPOS   0              // Constants for drawing status window
#define CONNECTCHARS 31             // (not used if display is not 8514-size)
#define ADVISEPOS    33
#define ADVISECHARS  17



//*** Menu Defines
    #define IDM_LOWESTMENUID    100
    #define IDM_CONNECTTOSERVER 100
    #define IDM_DOTRANSACTION   101
    #define IDM_STARTHOTADVISE  102
    #define IDM_STOPHOTADVISE   103
    #define IDM_STARTWARMADVISE 104
    #define IDM_STOPWARMADVISE  105
    #define IDM_SYSTOPICS       106
    #define IDM_ITEMLIST        107
    #define IDM_SYSITEMS        108
    #define IDM_FORMATS         109
    #define IDM_STATUS          110
    #define IDM_RTNMSG          111
    #define IDM_SVRHELP         112
    #define IDM_WHATDOIDO       114
    #define IDM_HIGHESTMENUID   114

//*** String table Defines
    #define IDS_SYSTOPICSTITLE  201
    #define IDS_ITEMLISTTITLE   202
    #define IDS_SYSITEMSTITLE   203
    #define IDS_FORMATSTITLE    204                 
    #define IDS_STATUSTITLE     205               
    #define IDS_RTNMSGTITLE     206               
    #define IDS_HELPTITLE       207
    #define IDS_SERVICENAME     208 
    #define IDS_SAMPLETOPIC     209
    #define IDS_NWDITEM         210
    #define IDS_CHANGEBMPITEM   211
    
    
// server constants


//*** Menu Defines
 
    #define IDM_ABOUT   113
    #define IDM_CHANGEBM       101


    #define IDC_STREAMERS  102
    #define IDC_CIRCLES    103
    #define IDC_SHAPES     104

