' COPYRIGHT:
'
'   (C) Copyright Microsoft Corp. 1993.  All rights reserved.
'
'   You have a royalty-free right to use, modify, reproduce and
'   distribute the Sample Files (and/or any modified version) in
'   any way you find useful, provided that you agree that
'   Microsoft has no warranty obligations or liability for any
'   Sample Application Files which are modified.
'
DefInt A-Z

Sub Sales_ShowForm ()

    Static fCompNameCopied

    fSalesRepAdded = False
    fTerritoryAdded = False

    'Get the filename from the company name file if it exists
    If Exist(CompanyNameFile) Then
        gCompanyName$ = GetCompanyNameFromFile(CompanyNameFile)
    Else
        gCompanyName$ = CompanyName
    End If

    FRM_SalesAnal.LBL_CompanyName.Caption = gCompanyName$

    If Exist(SalesRepFile) Then
        Call ReadFileIntoList(FRM_SalesAnal.CMB_SalesRep, SalesRepFile)
    Else
        FRM_SalesAnal.CMB_SalesRep.AddItem "Bugs Bunny"
        FRM_SalesAnal.CMB_SalesRep.AddItem "Elmer Fudd"
        FRM_SalesAnal.CMB_SalesRep.AddItem "Daffy Duck"
    End If

    If FRM_SalesAnal.CMB_SalesRep.ListCount > 0 Then
        FRM_SalesAnal.CMB_SalesRep.ListIndex = 0
    End If

    If Exist(TerritoryFile) Then
        Call ReadFileIntoList(FRM_SalesAnal.CMB_Territory, TerritoryFile)
    Else
        FRM_SalesAnal.CMB_Territory.AddItem "Toronto"
        FRM_SalesAnal.CMB_Territory.AddItem "Vancouver"
        FRM_SalesAnal.CMB_Territory.AddItem "Montreal"
    End If
    
    If FRM_SalesAnal.CMB_Territory.ListCount > 0 Then
        FRM_SalesAnal.CMB_Territory.ListIndex = 0
    End If

    If RTrim$(SalesAnalysis.IndexItems.Territory) <> "" Then

        FRM_SalesAnal.BE_Month.Text = Format$(SalesAnalysis.IndexItems.ReportDate, "MM")
        FRM_SalesAnal.BE_Year.Text = Format$(SalesAnalysis.IndexItems.ReportDate, "YY")

        FRM_SalesAnal.CMB_SalesRep.ListIndex = FindMatchingListItem(FRM_SalesAnal.CMB_SalesRep, SalesAnalysis.IndexItems.SalesRep)
        FRM_SalesAnal.CMB_Territory.ListIndex = FindMatchingListItem(FRM_SalesAnal.CMB_Territory, SalesAnalysis.IndexItems.Territory)

    Else

        'Assign the current month and year to the pen edit field
        FRM_SalesAnal.BE_Month.Text = Format$(Now, "MM")
        FRM_SalesAnal.BE_Year.Text = Format$(Now, "YY")

    End If
    
    FRM_SalesAnal.Hide

    FRM_SalesAnal.Left = 0
    FRM_SalesAnal.Top = 0
    FRM_SalesAnal.Width = Screen.Width
    FRM_SalesAnal.Height = Screen.Height
    
    'Copy the logo repetitively across the top of the form
    LOGOWIDTH = FRM_FormImages.PIC_Logo.Width
    LOGOHEIGHT = FRM_FormImages.PIC_Logo.Height

    For x = 0 To FRM_SalesAnal.ScaleWidth Step LOGOWIDTH
        r = bitblt(FRM_SalesAnal.hDC, x, 0, LOGOWIDTH, LOGOHEIGHT, FRM_FormImages.PIC_Logo.hDC, 0, 0, SRCCOPY)
    Next

    FRM_SalesAnal.Show

    FRM_SalesAnal.LBL_CompanyName.Left = 0
    FRM_SalesAnal.LBL_CompanyName.Width = FRM_SalesAnal.ScaleWidth
    r = DoEvents()

    If Not fCompNameCopied Then
        fCompNameCopied = True

        'Copy the image of the company name to the temporary pictures
        'Below is a work around for a problem of the company names not
        'showing up in the Selling and Activity forms.
        hWndCompName = GethWnd(FRM_SalesAnal.LBL_CompanyName)
        hDCCompName = GetDC(hWndCompName)
        
        r = bitblt(FRM_FormImages.PIC_FormImage(0).hDC, LBLLEFT, LBLTOP, LBLWIDTH, LBLHEIGHT, hDCCompName, LBLLEFT, LBLTOP, SRCCOPY)
        r = bitblt(FRM_FormImages.PIC_FormImage(1).hDC, LBLLEFT, LBLTOP, LBLWIDTH, LBLHEIGHT, hDCCompName, LBLLEFT, LBLTOP, SRCCOPY)

        ret = ReleaseDC(hWndCompName, hDCCompName)

        FRM_SalesAnal.Refresh

    End If



End Sub

'***********************************************************
'* Title:
'*      FindMatchingListItem()
'*
'* Description:
'*      Returns the list index of the list item which matches
'*      the text passed in as a parameter.
'***********************************************************
Function FindMatchingListItem (Combo As Control, Txt$)

    i = 0
    While i < Combo.ListCount
        If UCase$(LTrim$(RTrim$(Txt$))) = UCase$(LTrim$(RTrim$(Combo.List(i)))) Then
            FindMatchingListItem = i
            Exit Function
        Else
            i = i + 1
        End If
    Wend

End Function

Sub ReadFileIntoList (ListCtl As Control, FileName$)
    
    On Error GoTo ReadFileExit

    FileHandle = FreeFile
    Open FileName$ For Input As #FileHandle

    While Not EOF(FileHandle)
        Line Input #FileHandle, l$
        
        If LTrim$(RTrim$(l$)) <> "" Then
            ListCtl.AddItem l$
        End If

    Wend

ReadFileAbort:
    On Error GoTo 0
    
    Close #FileHandle

Exit Sub

ReadFileExit:
    Resume ReadFileAbort

End Sub

