//*****************************************************************************
//
//	FILE: SETDLG.H
//
//  Comments: This file contains values that are specific to the file
//	      SETDLG.C.
//
//   History: Date	Author		 Reason
//	      --------	---------------  -------
//	      9/30/92	David Flenniken  create/modified
//*****************************************************************************

// value of the left most list box.
#define IDDS_RC        22000

// values for each one of the controls on the right
#define IDDS_TEXT0     22001
#define IDDS_TEXT1     22002
#define IDDS_TEXT2     22003
#define IDDS_TEXT3     22004
#define IDDS_TEXT4     22005
#define IDDS_TEXT5     22006
#define IDDS_TEXT6     22007
#define IDDS_0	       22011
#define IDDS_1	       22012
#define IDDS_2	       22013
#define IDDS_3	       22014
#define IDDS_4	       22015
#define IDDS_5	       22016
#define IDDS_6	       22017

// Button values
#define IDDS_ACCEPT    22023
#define IDDS_RESTORE   22024

// Listbox and scroll bar values
#define IDDS_FLAGS     21025
#define IDDS_SCROLL    21026

// Dummy buffer value
#define BUFMAX 80

// Values used when copying data to and from the global and temp RC locations
#define ALL_OF_IT  -1
#define COPY_TO_TEMP_RC   TRUE
#define COPY_FROM_TEMP_RC FALSE

// This value is set if the user is leaving the dialog so that the values
// will not get updated.
BOOL gbCanceled;

// We need to know which item is selected all the time.
int giCurPos,giOldPos;

// Just to help with data collection and whatnot.
BOOL bJustChanged,bFirstTime;

// New type for dynamic controls.
typedef struct Controltag
{
   HWND Label;
   HWND Control;
} CON, FAR * LPCON;

// This is the array of controls that are dynamically shown and hidden
// depending on the user's selection.  At load time it is stuffed with
// the control type and handle.
CON grgControls[7];

// The Scrool and list box handles wouldn't fit into the structure above.
HWND ghScroll;
HWND ghList;

// Window position for INI file.
int giSetx,giSety;

// Scrolling variables.
int giScrollPos,giScrollExtent;
int giScrollOld;

// End-of-File
