//*****************************************************************************
//
//	FILE: TABLES.INC
//
//  Comments: This file contains a number of structure that need to be
//	      initialized at compile time.
//
//   History: Date	Author		 Reason
//	      --------	---------------  -------
//	      9/30/92	David Flenniken  create/modified
//*****************************************************************************

#include "Tables.h"

//*****************************************************************************
//
// The following structures are the ones that hold the flags and associated
// values for the RC options that contain flags.  These structure get pointed
// to in the main structure at the end of this file.
//
//*****************************************************************************
OPTION_STR gNull[NULLMAX]=
{
   {0,0}
};

OPTION_STR grcp[RCPMAX]=
{
   {RCP_LEFTHAND,	    "LEFTHAND"},
   {RCP_MAPCHAR,	    "MAPCHAR"},
   {0,			    NULL}
};

OPTION_STR grcip[RCIPMAX]=
{
   {RCIP_ALLANSICHAR,	  "ALLANSICHAR"},
   {RCIP_MASK,		  "MASK"},
   {0,			  NULL}
};


OPTION_STR galc[ALCMAX]=
{
   {ALC_ALL,		    "ALL"},
   {ALC_ALPHA,		    "ALPHA"},
   {ALC_ALPHANUMERIC,	    "ALPHANUMERIC"},
   {ALC_DBCS,		    "DBCS"},
   {ALC_DEFAULT,	    "DEFAULT"},
   {ALC_GESTURE,	    "GESTURE"},
   {ALC_HIRAGANA,	    "HIRAGANA"},
   {ALC_KANJI,		    "KANJI"},
   {ALC_KATAKANA,	    "KATAKANA"},
   {ALC_LCALPHA,	    "LCALPHA"},
   {ALC_MATH,		    "MATH"},
   {ALC_NONPRINT,	    "NONPRINT"},
   {ALC_MONETARY,	    "MONETARY"},
   {ALC_NOPRIORITY,	    "NOPRIORITY"},
   {ALC_NUMERIC,	    "NUMERIC"},
   {ALC_OEM,		    "OEM"},
   {ALC_OTHER,		    "OTHER"},
   {ALC_PUNC,		    "PUNC"},
   {ALC_RESERVED,	    "RESERVED"},
   {ALC_SYSMINIMUM,	    "SYSMINIMUM"},
   {ALC_UCALPHA,	    "UCALPHA"},
   {ALC_USEBITMAP,	    "USEBITMAP"},
   {ALC_WHITE,		    "WHITE"},
   {0,			    NULL}
};


OPTION_STR gguide[GUIDEMAX]=
{
   {1	     ,"\txOrigin"},
   {1	     ,"\tyOrigin"},
   {1	     ,"\tcxbox"},
   {1	     ,"\tcyBox"},
   {1	     ,"\tcxBase"},
   {1	     ,"\tcyBase"},
   {1	     ,"\tcHorzBox"},
   {1	     ,"\tcVertBox"},
   {1	     ,"\tcyMid"},
   {0	     ,NULL}
};

OPTION_STR glpcm[LPCMMAX]=
{
   {PCM_ADDDEFAULTS	   ,"ADDDEFAULTS"},
   {PCM_INVERT		   ,"INVERT"},
   {PCM_PENUP		   ,"PENUP"},
   {PCM_RANGE		   ,"RANGE"},
   {PCM_RECTBOUND	   ,"RECTBOUND"},
   {PCM_RECTEXCLUDE	   ,"RECTEXCLUDE"},
   {PCM_TIMEOUT 	   ,"TIMEOUT"},
   {0,			    NULL}
};

OPTION_STR glrco[]=
{
   {RCO_BOXED		   ,"BOXED"},
   {RCO_COLDRECOG	   ,"COLDRECOG"},
   {RCO_DISABLEGESMAP	   ,"DISABLEGESMAP"},
   {RCO_NOFLASHCURSOR	   ,"NOFLASHCURSOR"},
   {RCO_NOFLASHUNKNOWN	   ,"NOFLASHUNKNOWN"},
   {RCO_NOHIDECURSOR	   ,"NOHIDECURSOR"},
   {RCO_NOHOOK		   ,"NOHOOK"},
   {RCO_NOPOINTEREVENT	   ,"NOPOINTEREVENT"},
   {RCO_NOSPACEBREAK	   ,"NOSPACEBREAK"},
   {RCO_SAVEALLDATA	   ,"SAVEALLDATA"},
   {RCO_SAVEHPENDATA	   ,"SAVEHPENDATA"},
   {RCO_SUGGEST 	   ,"SUGGEST"},
   {RCO_TABLETCOORD	   ,"TABLETCOORD"},
   {0,			    NULL}
};

OPTION_STR grrm[RRMMAX]=
{
   {RRM_COMPLETE	   ,"COMPLETE"},
   {RRM_NEWLINE 	   ,"NEWLINE"},
   {RRM_STROKE		   ,"STROKE"},
   {RRM_SYMBOL		   ,"SYMBOL"},
   {RRM_WORD		   ,"WORD"},
   {0,			    NULL}
};

OPTION_STR grcor[RCORMAX]=
{
   {RCOR_LEFT		   ,"LEFT"},
   {RCOR_NORMAL 	   ,"NORMAL"},
   {RCOR_RIGHT		   ,"RIGHT"},
   {RCOR_UPSIDEDOWN	   ,"UPSIDEDOWN"},
   {0,			    NULL}
};

OPTION_STR grcd[RCDMAX]=
{
   {RCD_BT		   ,"RCD_BT"},
   {RCD_DEFAULT 	   ,"RCD_DEFAULT"},
   {RCD_LR		   ,"RCD_LR"},
   {RCD_RL		   ,"RCD_RL"},
   {RCD_TB		   ,"RCD_TB"},
   {0,			    NULL}
};

OPTION_STR grcrt[RCRTMAX]=
{
   {RCRT_ALREADYPROCESSED, "ALREADYPROCESSED"},
   {RCRT_GESTURE,	   "GESTURE"},
   {RCRT_GESTURETOKEYS,    "GESTURETOKEYS"},
   {RCRT_GESTURETRANSLATED,"GESTURETRANSLATED"},
   {RCRT_NORECOG,	   "NORECOG"},
   {RCRT_NOSYMBOLMATCH,    "NOSYMBOLMATCH"},
   {RCRT_PRIVATE,	   "PRIVATE"},
   {RCRT_UNIDENTIFIED,	   "UNIDENTIFIED"},
   {0,			    NULL}
};



//*****************************************************************************
//
// The following structures are the ones that contain the labels for the
// dynamically shown controls in the set dialog.
//
//*****************************************************************************

LABEL_STR gNull_str[NULL_STRMAX]=
{
   {NULL}
};


LABEL_STR gdw_str[DWORDHEX_STRMAX]=
{
   {"Long-Hex"},
   {NULL}
};

LABEL_STR gint_str[INT_STRMAX]=
{
   {"Integer"},
   {NULL}
};


LABEL_STR gword_str[WORD_STRMAX]=
{
   {"Word-hex"},
   {NULL}
};


LABEL_STR grect_str[RECT_STRMAX]=
{
   {"left"},
   {"top"},
   {"right"},
   {"bottom"},
   {NULL}
};


LABEL_STR gguide_str[GUIDE_STRMAX]=
{
   {"xOrigin"},
   {"yOrigin"},
   {"cxBox"},
   {"cyBox"},
   {"cxBase"},
   {"cyBase"},
   {"cHorzBox"},
   {"cVertBox"},
   {"cyMid"},
   {NULL}
};


LABEL_STR gbyte_str[BYTE_STRMAX]=
{
   {"Byte-ptr"},
   {NULL}
};

LABEL_STR grglpdf_str[RGLPDF_STRMAX]=
{
   {"position 0"},
   {"position 1"},
   {"position 2"},
   {"position 3"},
   {"position 4"},
   {"position 5"},
   {"position 6"},
   {"position 7"},
   {"position 8"},
   {"position 9"},
   {"position 10"},
   {"position 11"},
   {"position 12"},
   {"position 13"},
   {"position 14"},
   {"position 15"},
   {NULL}
};

LABEL_STR greserved_str[RESERVED_STRMAX]=
{
   {"position 0"},
   {"position 1"},
   {"position 2"},
   {"position 3"},
   {"position 4"},
   {"position 5"},
   {"position 6"},
   {"position 7"},
   {NULL}
};


LABEL_STR grgbfalc_str[RGBFALC_STRMAX]=
{
   {"byte 0"},
   {"byte 1"},
   {"byte 2"},
   {"byte 3"},
   {"byte 4"},
   {"byte 5"},
   {"byte 6"},
   {"byte 7"},
   {"byte 8"},
   {"byte 9"},
   {"byte 10"},
   {"byte 11"},
   {"byte 12"},
   {"byte 13"},
   {"byte 14"},
   {"byte 15"},
   {"byte 16"},
   {"byte 17"},
   {"byte 18"},
   {"byte 19"},
   {"byte 20"},
   {"byte 21"},
   {"byte 22"},
   {"byte 23"},
   {"byte 24"},
   {"byte 25"},
   {"byte 26"},
   {"byte 27"},
   {"byte 28"},
   {"byte 29"},
   {"byte 30"},
   {"byte 31"},
   {NULL}
};


//*****************************************************************************
//
// The following two structures are key to the operation of this applciation.
//
// The first field contains a boolean that is initialized to zero at compile
// time.  When the user selects items in the View dialog's list boxes these
// values will change to 1 (TRUE).
//
// The second position contains a string that discribes the option.  These
// strings are displayed in the Set dialog, view dialog and Main window
// listbox.
//
// The next position is used when the data is displayed in the main window's
// list box (DISPLAY.C).
//
// The next field points to the LABEL_STR that contains the title for the
// controls that are displayed in the Set dialog's dynamical controls.
//
// The next WORD defines the type of data this field contains. See TABLES.H
// for the expanded version of the values.  The data "TYPE" description
// controls who the data is handled by this application.
//
// The next field is a pointer to where the data is located in the global
// RC structure.  Note that this structure defines this pointer as a void
// far pointer.  So each time the data is referenced in the program this
// pointer gets cast to a particular type.
//
// The next field is just like the previous except that it is used by the
// Set Dialog to hold the temprary information.
//
// Finally, the last field is a pointer to a OPTION_STR structure that contains
// the flags and their associated values.  This is used in the set dialog
// any time the data contains flags that the user can select.
//
//*****************************************************************************


OPTIONS gRc_Opt[NUMOF_RC_OPTIONS] =
{
{0,"alc",	  "%#9.8lx",	 &gdw_str,    DWHF,	  &grc.alc,		     &grcTmp.alc,		&galc},
{0,"alcPriority", "%#9.8lx",	 &gdw_str,    DWHF,	  &grc.alcPriority,	     &grcTmp.alcPriority,	&galc},
{0,"clErrorLevel","%i", 	 &gint_str,   BI,	  &grc.clErrorLevel,	     &grcTmp.clErrorLevel,	&gNull},
{0,"dwAppParam",  "%#9.8lx",	 &gdw_str,    DWH,	  &grc.dwAppParam,	     &grcTmp.dwAppParam,	&gNull},
{0,"dwDictParam", "%#9.8lx",	 &gdw_str,    DWH,	  &grc.dwDictParam,	     &grcTmp.dwDictParam,	&gNull},
{0,"dwRecognizer","%#9.8lx",	 &gdw_str,    DWH,	  &grc.dwRecognizer,	     &grcTmp.dwRecognizer,	&gNull},
{0,"guide",	  "Set Full Display",&gguide_str, BG,	  &grc.guide,		     &grcTmp.guide,		&gguide},
{0,"hrec",	  "%#5.4x",	 &gword_str,  WH,	  &grc.hrec,		     &grcTmp.hrec,		&gNull},
{0,"hwnd",	  "%#5.4x",	 &gword_str,  WH,	  &grc.hwnd,		     &grcTmp.hwnd,		&gNull},
{0,"lPcm",	  "%#9.8lx",	 &gdw_str,    DWHF,	  &grc.lPcm,		     &grcTmp.lPcm,		&glpcm},
{0,"lpfnYield",   "%#9.8lx",	 &gdw_str,    DWH,	  &grc.lpfnYield,	     &grcTmp.lpfnYield, 	&gNull},
{0,"lpLanguage",  "",		 &gbyte_str,  PL,	  &grc.lpLanguage,	     &grcTmp.lpLanguage,	&gNull},
{0,"lpUser",	  "",		 &gbyte_str,  PU,	  &grc.lpUser,		     &grcTmp.lpUser,		&gNull},
{0,"lRcOptions",  "%#9.8lx",	 &gdw_str,    DWHF,	  &grc.lRcOptions,	     &grcTmp.lRcOptions,	&glrco},
{0,"nInkWidth",   "%i", 	 &gint_str,   BI,	  &grc.nInkWidth,	     &grcTmp.nInkWidth, 	&gNull},
{0,"rectBound",   "%i,%i,%i,%i", &grect_str,  BR,	  &grc.rectBound,	     &grcTmp.rectBound, 	&gNull},
{0,"rectExclude", "%i,%i,%i,%i", &grect_str,  BR,	  &grc.rectExclude,	     &grcTmp.rectExclude,	&gNull},
{0,"rgbfAlc",	  "Set Full Display", &grgbfalc_str,OALC, &grc.rgbfAlc, 	     &grc.rgbfAlc,			&gNull},
{0,"rgbInk",	  "%li",	 &gdw_str,    DWH,	  &grc.rgbInk,		     &grcTmp.rgbInk,		&gNull},
{0,"rglpdf",	  "Set Full Display",&grglpdf_str,ODF,	  &grc.rglpdf,		     &grc.rglpdf,		&gNull},
{0,"rgwReserved", "Set Full Display",&greserved_str,ORES, &grc.rgwReserved,	     &grc.rgwReserved,		&gNull},
{0,"wCountry",	  "%#5.4x",	 &gword_str,  WH,	  &grc.wCountry,	     &grcTmp.wCountry,		&gNull},
{0,"wEventRef",   "%#5.4x",	 &gword_str,  WH,	  &grc.wEventRef,	     &grcTmp.wEventRef, 	&gNull},
{0,"wIntlPreferences","%#5.4x",  &gword_str,  WHF,	  &grc.wIntlPreferences,     &grcTmp.wIntlPreferences,	&grcip},
{0,"wRcDirect",   "%#5.4x",	 &gword_str,  WH,	  &grc.wRcDirect,	     &grcTmp.wRcDirect, 	&grcd},
{0,"wRcOrient",   "%i", 	 &gint_str,   BIF,	  &grc.wRcOrient,	     &grcTmp.wRcOrient, 	&grcor},
{0,"wRcPreferences","%#5.4x",	 &gword_str,  WHF,	  &grc.wRcPreferences,	     &grcTmp.wRcPreferences,	&grcp},
{0,"wResultMode", "%#5.4x",	 &gword_str,  BIF,	  &grc.wResultMode,	     &grcTmp.wResultMode,	&grrm},
{0,"wTimeOut",	  "%#5.4x",	 &gword_str,  WH,	  &grc.wTimeOut,	     &grcTmp.wTimeOut,		&gNull},
{0,"wTryDictionary","%i",	 &gint_str,   BI,	  &grc.wTryDictionary,	     &grcTmp.wTryDictionary,	&gNull},
{0, NULL,	   NULL,	 &gNull_str,  TYPE_OTHER, &gNull,		     &gNull,			&gNull}
};



OPTIONS gRcR_Opt[NUMOF_RCR_OPTIONS] =
{
// BOOL,  Str,	   Str,   Secondard options,Type,	   Data,		      depndent data		 Flags
{0,"cHotSpot",	  "%i", 	 &gNull_str,BI,        &gresult.syg.cHotSpot,	  &gresult.syg.cHotSpot,     &gNull},
{0,"cSyc",	  "%i", 	 &gNull_str,BI,        &gresult.syg.cSyc,	  &gresult.syg.cSyc,	     &gNull},
{0,"cSye",	  "%i", 	 &gNull_str,BI,        &gresult.syg.cSye,	  &gresult.syg.cSye,	     &gNull},
{0,"cSyv",	  "%i", 	 &gNull_str,BI,        &gresult.cSyv,		  &gresult.cSyv,	     &gNull},
{0,"hpendata",	  "%#5.4x",	 &gNull_str,WH,        &gresult.hpendata,	  &gresult.hpendata,	     &gNull},
{0,"hSyv",	  "%#5.4x",	 &gNull_str,WH,        &gresult.hSyv,		  &gresult.hSyv,	     &gNull},
{0,"lpsyc",	  "%#9.8lx",	 &gNull_str,PSYC,      &gresult.syg.lpsyc,	  &gresult.syg.cSyc,	     &gNull},
{0,"lpsye",	  "%#9.8lx",	 &gNull_str,PSYE,      &gresult.syg.lpsye,	  &gresult.syg.cSye,	     &gNull},
{0,"lpsyv",	  "%#9.8lx",	 &gNull_str,PSYV,      &gresult.lpsyv,		  &gresult.cSyv,	     &gNull},
{0,"lRecogVal",   "%#9.8lx",	 &gNull_str,DWH,       &gresult.syg.lRecogVal,	  &gresult.syg.lRecogVal,    &gNull},
{0,"nBaseLine",   "%i", 	 &gNull_str,BI,        &gresult.nBaseLine,	  &gresult.nBaseLine,	     &gNull},
{0,"nFirstBox",   "%i", 	 &gNull_str,BI,        &gresult.syg.nFirstBox,	  &gresult.syg.nFirstBox,    &gNull},
{0,"nMidLine",	  "%i", 	 &gNull_str,BI,        &gresult.nMidLine,	  &gresult.nMidLine,	     &gNull},
{0,"pntEnd",	  "(%i,%i)",	 &gNull_str,BP,        &gresult.pntEnd, 	  &gresult.pntEnd,	     &gNull},
{0,"rectBoundInk","%i,%i,%i,%i", &gNull_str,BR,        &gresult.rectBoundInk,	  &gresult.rectBoundInk,     &gNull},
{0,"rgpntHotSpots","(%i,%i)",	 &gNull_str,OHOT,      &gresult.syg.rgpntHotSpots,&gresult.syg.rgpntHotSpots,&gNull},
{0,"wResultsType","%#5.4x",	 &gNull_str,WHF,       &gresult.wResultsType,	  &gresult.wResultsType,     &grcrt},
{0, NULL,	   NULL,	 &gNull_str,TYPE_OTHER,&gNull,			  &gNull,		     &gNull}
};
// missing lprc...
